#ifndef SC_EVENT_H
#define SC_EVENT_H

#include <scoot_tags.h>

namespace sc_core
{

class sc_event_finder
{};
#ifdef SCOOT_SKIP_UPDATE_PHASES
struct sc_event
{
    sc_event():value(false)
    {
        scoot_event_decl(this);
    }

    bool notified() const
    {
        return value;
    }

    void do_notify(bool v)
    {
        value = v;
    }

    bool value;
};
#else
class sc_event
{
    public:
    sc_event():value(false), next_value(false)
    {
        scoot_event_decl(this);
    }

    void notify(int t)
    {
        if(t == 0)
        {
            next_value = true;
            timed_notification = false;
        }
        else if(next_value == false)
        {
            counter = t;
            timed_notification = true;
        }
    }

    bool notified() const
    {
        return value;
    }

    private:

    void do_delta_notification()
    {
        value = next_value;
        next_value = false;
    }

    void do_timed_notification()
    {
        counter--;
        value = timed_notification & (counter == 0);
        timed_notification = timed_notification & !value;
    }
    bool value;
    bool next_value;
    bool timed_notification;
    int counter;
};
#endif

} // namespace sc_core
#endif
